<?php
namespace Teknisa\CADEST\Services;

// use Zeedhi\Framework\DataSource\FilterCriteria;
// use Teknisa\Libs\Util\Environment;

// use Zeedhi\Framework\DTO;
// use Zeedhi\Framework\DataSource\DataSet;

// use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
// use Zeedhi\Framework\DB\StoredProcedure\Param;
use Teknisa\CADEST\Factories\Ger10000SegmentoDeMercadoFactory;

class Ger10000SegmentoDeMercadoService extends \Teknisa\CADEST\Controllers\TeknisaCrud {

// 	protected $environment;
// 	protected $dataSourceManager;
// 	protected $newCode;
	protected $factory;

    public function __construct(/*Environment $environment, $dataSourceManager, $newCode, */$factory){
        // $this->environment = $environment;
        // $this->dataSourceManager = $dataSourceManager;
        // $this->newCode = $newCode;
        $this->factory = $factory;
    }

    
    public function saveProdutosSegmento($row) {
        try{
            $nvCadastrado = $this->factory->verificaNivelCadastrado($row);
        
            if(!$nvCadastrado){
                $maxNvProd = $this->factory->getNvMaxProd();
                $row['CDNVPRODUTO'] = $maxNvProd[0]['CDNVPRODUTO'];
                
                $this->factory->insereProdutoNivel($row);
                $this->factory->insereProdutoNivelSegmento($row);
            }else{
                if($nvCadastrado[0]['ID'] == '1'){
                    throw new \Exception("Existe produto de nível superior cadastrado");
                }else if($nvCadastrado[0]['ID'] == '2'){
                    throw new \Exception("Existe produto de nível inferior cadastrado");
                }
            }
        }
        catch(\Exception $e) {
            $pos = strpos($e->getMessage(), 'ORA-00001');
            if($pos===false){
                throw $e;
            }
            else{
                throw new \Exception("Produto já cadastrado.", 1);
            }
        }
        
    }
    
    public function deleteProdutosSegmento($row) {
        try{
            if(!$row['PRICECHECK']){
                $precoCadastrado = $this->factory->produtoPrecoCadastrado($row);
                if(!$precoCadastrado){
                    $this->factory->deleteProdutoNivelSegmento($row);
                    $this->factory->deleteProdutoNivel($row);
                }else{
                    throw new \Exception("Produto(s) com preço cadastrado.");
                }
            }else{
                $this->factory->deleteProdutoNivelSegmento($row);
                $this->factory->deleteProdutoNivel($row);
            }
        }
        catch(\Exception $e) {
            throw $e;
        }
    }
    
}